//
//  DotEmuChannelViewController.h
//  DotEmuChannel
//
//  Created by DotEmu on 27/09/10.
//  Copyright DotEmu 2010. All rights reserved.
//  Author: Guillaume SIORAK
//  Email: guillaume.siorak@dotemu.com
//

#import "DotEmuChannelViewController.h"
#import "iphone_main.h"
#import "iphone_common.h"
#import "Reachability.h"
#import "Base64.h"

int _netR;
extern NSString* STORE_GAME;
extern bool store;

@implementation DotEmuChannelViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
	//LANGUAGE 
	_languages = [NSLocale preferredLanguages];
    _preferredLang = [[_languages objectAtIndex:0] retain];
	
	if( ![_preferredLang isEqualToString:@"fr"] )
		_Lang = @"en";
	else
		_Lang = @"fr";
	
	//SCROLLVIEW
	[_scrollView setContentSize:CGSizeMake( 320, 1200 ) ];
	[self.view insertSubview:_scrollView aboveSubview:_background];
	
	//BUTTONS
	_back.enabled = YES;
	[self.view insertSubview:_back aboveSubview:_background];
	
	//TEXTFIELD + BUTTON EMAIL
	if( [_Lang isEqualToString:@"en"] )
	{
		[_emailToGet setPlaceholder:@"Enter your email here..."];
		[_sendEmail setTitle:@"Submit" forState:UIControlStateNormal];
	}
	else if( [_Lang isEqualToString:@"fr"] )
	{
		[_emailToGet setPlaceholder:@"Entrez votre adresse email ici..."];
		[_sendEmail setTitle:@"Envoyer" forState:UIControlStateNormal];		
	}
		
	[self.view insertSubview:_emailToGet aboveSubview:_background];
	[self.view insertSubview:_sendEmail aboveSubview:_background];
	[self.view insertSubview:_emailActivityIndicator aboveSubview:_background];	
	
	//LABEL
	if( [_Lang isEqualToString:@"en"] )
	{
		_benefitsL.text = @"Benefits: new games, sales, redeem code alerts and more...";
	}
	else if( [_Lang isEqualToString:@"fr"] )
	{
		_benefitsL.text = @"Avantages : nouvelles sorties, réductions, codes promo...";		
	}	
	[self.view insertSubview:_benefitsL aboveSubview:_background];	
	
	//FB & TWITTER
	[self.view insertSubview:_FB aboveSubview:_background];	
	[self.view insertSubview:_twitter aboveSubview:_background];	
	
	//DEFAULT USER
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	if( [defaults boolForKey:STORE_GAME] == NO )
	{
		[defaults setBool:YES forKey:STORE_GAME];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"storeUpdateOffNotif" object:nil];		
	}
	[[NSUserDefaults standardUserDefaults] synchronize];
	
	//test autorotation
	store = true;
	decrem = 0;
	
	//SUPER
    [super viewDidLoad];
}

-(void) touchesBegan :(NSSet *) touches withEvent:(UIEvent *)event
{
	NSLog(@"touches began");
	[_emailToGet resignFirstResponder];
	
	[super touchesBegan:touches withEvent:event];
}

- (IBAction) submitClicked:(id)sender
{
	if( _emailToGet.text.length > 0 )
	{
		[_emailToGet resignFirstResponder];		
		emailNSURL = true;	
		_sendEmail.enabled = NO;
		
		NSLog(@"sending email to iPhone newsletter URL");
		
		NSMutableURLRequest * request = [[[NSMutableURLRequest alloc] init] autorelease];
		[request setURL:[NSURL URLWithString:@"http://www.dotemu.com/dotemu_shop/iphone_newsletter"]];
		[request setCachePolicy: NSURLRequestReloadIgnoringLocalCacheData];
		[request setTimeoutInterval:15.0];
		[request setHTTPMethod:@"POST"];
		[request setValue:@"application/x-www-form-urlencoded; charset=utf-8" forHTTPHeaderField:@"content-type"];
		
		NSData* aData = [_emailToGet.text dataUsingEncoding: NSUTF8StringEncoding];
		NSString * nameEncoded = [aData base64Encoding]; // ==> problem +(sign), need to be url-encoded
		NSString * nameURLEncoded = (NSString *)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)nameEncoded, NULL, (CFStringRef)@"!*'();:@&=+$,/?%#[]", kCFStringEncodingUTF8);
		
		NSString* type = @"iPhone";
		NSString* platform_version = [NSString stringWithFormat:@"iOS %.01f", [[UIDevice currentDevice].systemVersion floatValue]];
		NSMutableString * postValues = [[NSMutableString alloc] initWithFormat:@"type=%@&platform_version=%@&email=%@&game=%@&lang=%@", type, platform_version, nameURLEncoded, [[[[NSBundle mainBundle] bundlePath] lastPathComponent] stringByDeletingPathExtension], _preferredLang];
		
		NSLog(@"POST values request : %@", postValues);
		
		NSData * postData = [NSData dataWithBytes: [postValues UTF8String] length: [postValues length]];
		[request setHTTPBody:postData];
		
		//NSUInteger byteCount = [postValues lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
		//[request setValue:[[NSString alloc] initWithFormat:@"%i", byteCount] forHTTPHeaderField:@"content-length"];
		[request setValue:[[NSString alloc] initWithFormat:@"%i", [postValues length]] forHTTPHeaderField:@"content-length"];
		
		/*NSLog(@"GO_playerName_txt.text : %@", GO_playerName_txt.text);
		 NSLog(@"Sending request : %@", request.URL.absoluteString);
		 NSLog(@"With POST values request : %@", postValues);
		 NSLog(@"With POST length : %i", [postValues length]);
		 NSLog(@"With POST data length : %i", [postData length]);*/
		//NSLog(@"lengthOfBytesUsingEncoding : %i", byteCount);
		
		if(_submitConnection != nil)
		{
			[_submitConnection release];
			_submitConnection = nil;
		}
		_submitConnection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
		
		if(_submitConnection)		NSLog(@"Connection created.");
		else						NSLog(@"Can't create a connection.");
		
		_sendEmail.hidden = YES;
		[_emailActivityIndicator startAnimating];
	}
}

- (IBAction) FBClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController FBClicked:");
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://www.facebook.com/dotemu"]];
}

- (IBAction) TwitterClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController TwitterClicked:");	
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://twitter.com/dotemu"]];
}

- (void)XMLLoading
{
	// Create the request.
	NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://corporate.dotemu.com/new_iPhoneStore.xml"]
											  cachePolicy:NSURLRequestUseProtocolCachePolicy
										  timeoutInterval:60.0];
	
	// create the connection with the request and start loading the data
	NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	if (theConnection) 
	{
		NSLog(@"connection OK");	
	    storeData = [[NSMutableData data] retain];
	} 
	else 
	{
		// Inform the user that the connection failed.
		NSLog(@"connection failed");
	}	
	emailNSURL = false;	
}

- (void) noInternetLoading
{
	NSLog(@"noInternetLoading");

	_activityIndicator.hidden = YES;
	[_activityIndicator stopAnimating];
	
	if( _scrollView != nil )
	{
		[_scrollView removeFromSuperview];		
		[_scrollView release];
		_scrollView = nil;
	}
	if( _activityIndicator != nil )
	{
		[_activityIndicator removeFromSuperview];		
		[_activityIndicator release];
		_activityIndicator = nil;
	}
	
	if( [_Lang isEqualToString:@"en"] )
	{
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error!" message:@"Network error. Check your Internet connection and try again later!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
		[alert show];
		[alert release];
	}
	else if( [_Lang isEqualToString:@"fr"] )
	{
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Erreur !" message:@"Problème de connexion. Reconnectez-vous et réessayez ultérieurement." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
		[alert show];
		[alert release];			
	}	
}

- (void)viewDidAppear:(BOOL)animated
{
	_emailToGet.hidden	= YES;
	_sendEmail.hidden	= YES;
	_FB.hidden			= YES;
	_twitter.hidden		= YES;
	_benefitsL.hidden	= YES;
	
	emailNSURL = false;
	
	_activityIndicator.hidden = NO;
	[_activityIndicator startAnimating];
	[self.view insertSubview:_activityIndicator aboveSubview:_background];
	
	//network ?
	Reachability* reachability = [Reachability reachabilityWithHostName:@"www.apple.com"];
	NetworkStatus remoteHostStatus = [reachability currentReachabilityStatus];
	
	if(remoteHostStatus == NotReachable) { NSLog(@"not reachable"); _netR = 0; }
	else if (remoteHostStatus == ReachableViaWWAN) { NSLog(@"reachable via wwan"); _netR = 1; }
	else if (remoteHostStatus == ReachableViaWiFi) { NSLog(@"reachable via wifi"); _netR = 2; }

	if( _netR == 0 )
	{
		[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(noInternetLoading) userInfo:nil repeats:NO];	
	}
	else
	{
		[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(XMLLoading) userInfo:nil repeats:NO];	
	}
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];
	return UIInterfaceOrientationPortrait;
	
    // Return YES for supported orientations
    //return UIDeviceOrientationIsPortrait(interfaceOrientation);
}

- (void)viewWillAppear:(BOOL)animated
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
}

- (void)didReceiveMemoryWarning
{
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc
{
	NSLog(@"DotEmuChannelViewController dealloc");
	
	//OUTLETS
	if( _background != nil )
	{
		[_background removeFromSuperview];		
		[_background release];
		_background = nil;
	}
	if( _scrollView != nil )
	{
		[_scrollView removeFromSuperview];		
		[_scrollView release];
		_scrollView = nil;	
	}
	if( _activityIndicator != nil )
	{
		[_activityIndicator removeFromSuperview];		
		[_activityIndicator release];
		_activityIndicator = nil;	
	}
	if( _back != nil )
	{
		[_back removeFromSuperview];		
		[_back release];		
		_back = nil;
	}
	if( _benefitsL != nil )
	{
		[_benefitsL removeFromSuperview];			
		[_benefitsL release];
		_benefitsL = nil;		
	}
	
	//ATTRIBUTES
	for( int i = 0; i < 50; ++i )
	{
		if( _GamesB[i] != nil )
		{		
			_GamesB[i] = nil;			
		}
		
		if( _GamesI[i] != nil )
		{			
			_GamesI[i] = nil;
		}		 
		
		if( _GamesL[i] != nil )
		{			
			_GamesL[i] = nil;
		}	
	}
	
	//GAMES
	for( int i = 0; i < 50; ++i )
	{
		if( _Games[i].gameName != nil )
		{	
			_Games[i].gameName = nil;
		}
		if( _Games[i].gameImg != nil )
		{	
			_Games[i].gameImg = nil;
		}
		if( _Games[i].gameURL != nil )
		{		
			_Games[i].gameURL = nil;		
		}
	}
	
	//XML
	if( storeData != nil )
	{
		[storeData release];
		storeData = nil;		
	}
	if( emailData != nil )
	{
		[emailData release];
		emailData = nil;		
	}
	if(_submitConnection != nil)
	{
		[_submitConnection release];
		_submitConnection = nil;
	}
	if( _emailActivityIndicator != nil )
	{
		[_emailActivityIndicator release];
		_emailActivityIndicator = nil;	
	}
	
	//LANGUAGES
	if( _languages != nil )
	{
		_languages = nil;			
	}
	if( _preferredLang != nil )
	{
		_preferredLang = nil;					
	}
	if( _Lang != nil )
	{
		_Lang = nil;					
	}

	store = false;
	
    [super dealloc];
} 

//METHODS
- (void) loadGames:(int)iid
{
	NSLog(@"DotEmuChannelViewController loadGames:(int)%d",iid);

	if( [_Games[iid].gameName isEqualToString:[[[[NSBundle mainBundle] bundlePath] lastPathComponent] stringByDeletingPathExtension]] )
	{
		decrem = 1;
		[_scrollView setContentSize:CGSizeMake( 320, (GAMES_TOTAL-decrem)*70 + 2 ) ];
		return;
	}
	
	UIImage* mg;
	
	if( iid == 0 )
		mg = [UIImage imageNamed:@"new.png"];	
	else if( (iid-decrem) % 2 == 0 )
		mg = [UIImage imageNamed:@"clair.png"];
	else
		mg = [UIImage imageNamed:@"fonce.png"];

	_GamesB[iid]		= [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	_GamesB[iid].frame	= CGRectMake( 10, ((iid-decrem)*70)+2, 300, 70 );	
	_GamesI[iid]		= [[UIImageView alloc] initWithFrame:CGRectMake( 10, ((iid-decrem)*70)+2, 300, 70 )];		
	_GamesL[iid]		= [[UITextView alloc ] initWithFrame:CGRectMake( 80, ((iid-decrem)*70)+25, 220, 43 )];		
	
	//button background
	_GamesI[iid].image = mg;
	[mg release];
	_GamesI[iid].hidden = YES;
	[_scrollView addSubview:_GamesI[iid]];
	
	//text
	_GamesL[iid].textColor = [UIColor whiteColor];
	_GamesL[iid].backgroundColor = [UIColor clearColor];
	_GamesL[iid].font = [UIFont fontWithName:@"Verdana" size:9];
	_GamesL[iid].scrollEnabled = NO;
	_GamesL[iid].editable = NO;
	_GamesL[iid].autoresizingMask = UIViewAutoresizingFlexibleHeight;
	_GamesL[iid].text = _Games[iid].gameDesc;
	[_GamesL[iid] setUserInteractionEnabled:NO];	
	_GamesL[iid].hidden = YES;	
	[_scrollView addSubview:_GamesL[iid]];
	
	//button
	[_GamesB[iid] setImage:_Games[iid].gameImg forState:UIControlStateNormal]; 		
	[_GamesB[iid] addTarget:self action:@selector(gameClicked:) forControlEvents:UIControlEventTouchDown];	
	_GamesB[iid].hidden = YES;		
	[_scrollView addSubview:_GamesB[iid]]; 	
}

- (void) clearGames:(int)iid
{
	if( _GamesB[iid] != nil && _GamesB[iid].superview != nil )
	{				
		[_GamesB[iid] removeFromSuperview];
		_GamesB[iid] = nil;
	}
	
	if( _GamesI[iid] != nil && _GamesI[iid].superview != nil )
	{
		[_GamesI[iid] removeFromSuperview];
		_GamesI[iid] = nil;
	}
	
	if( _GamesL[iid] != nil && _GamesL[iid].superview != nil )
	{
		[_GamesL[iid] removeFromSuperview];
		_GamesL[iid] = nil;
	}
}

//ACTIONS
- (IBAction) backButtonClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController backButtonClicked");
	_back.enabled = NO;
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"enableMenuUINotif" object:nil];	
	
	[(iPhoneMain*)[[UIApplication sharedApplication] delegate] switchToLandscapeView];
}

- (IBAction) gameClicked:(id)sender
{
	NSLog(@"DotEmuChannelViewController gameClicked");
	for( int i = 0; i < GAMES_TOTAL; ++i )
	{
		if( _GamesB[i] == sender )
			[[UIApplication sharedApplication] openURL:[NSURL URLWithString:_Games[i].gameURL ]];		
	}
}

//XML DELEGATES
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName 
	attributes:(NSDictionary *)attributeDict 
{	
	NSLog(@"parser didStartElement %@",elementName);

	NSString *ss;
	
	if([elementName isEqualToString:@"NOMBRE_JEUX"])
	{
		GAMES_TOTAL = [[attributeDict objectForKey:@"nb"] integerValue];
		[_scrollView setContentSize:CGSizeMake( 320, GAMES_TOTAL*70 + 2 ) ];		
	}
	if([elementName isEqualToString:@"GAME"])
	{
		currentID = [[attributeDict objectForKey:@"ID"] integerValue];
		_Games[currentID].gameID = currentID;	
	}
	if([elementName isEqualToString:@"NAME"])
	{
		ss = [attributeDict objectForKey:@"name"];
		_Games[currentID].gameName = ss;	
	}
	if([elementName isEqualToString:@"IMG"])
	{
		ss = [attributeDict objectForKey:@"img"];
		UIImage *img = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:ss]]];
		_Games[currentID].gameImg = img;		
	}
	
	if( [_Lang isEqualToString:@"en"] )
	{
		if([elementName isEqualToString:@"DESC_EN"])
		{
			ss = [[attributeDict objectForKey:@"desc_en"] retain];
			_Games[currentID].gameDesc = ss;		
		}
	}
	else if( [_Lang isEqualToString:@"fr"] )
	{
		if([elementName isEqualToString:@"DESC_FR"])
		{
			ss = [[attributeDict objectForKey:@"desc_fr"] retain];
			_Games[currentID].gameDesc = ss;		
		}	
	}
	
	if([elementName isEqualToString:@"URL"])
	{
		ss = [[attributeDict objectForKey:@"url"] retain];
		_Games[currentID].gameURL = ss;
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string 
{	

}

- (void) showUI
{
	_activityIndicator.hidden = YES;
	[_activityIndicator stopAnimating];		

	_emailToGet.hidden	= NO;
	_sendEmail.hidden	= NO;
	_FB.hidden			= NO;
	_twitter.hidden		= NO;	
	_benefitsL.hidden	= NO;
	
	for( int i = 0; i < GAMES_TOTAL; ++i )
	{
		if( _GamesB[i] )
		{
			_GamesB[i].hidden = NO;
			_GamesI[i].hidden = NO;
			_GamesL[i].hidden = NO;
		}
	}	
}

- (void) scrollToTop
{
	[_scrollView setContentOffset:CGPointMake(0.0,0.0) animated:NO];
	[NSTimer scheduledTimerWithTimeInterval:0.15 target:self selector:@selector(showUI) userInfo:nil repeats:NO];	
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	NSLog(@"parser didEndElement %@",elementName);
	
	//LOAD GAME
	if([elementName isEqualToString:@"STORE"])
	{
		for( int i = 0; i < GAMES_TOTAL; ++i )
		{
			[self clearGames:i];
			[self loadGames:i];
		}
		[NSTimer scheduledTimerWithTimeInterval:0.35 target:self selector:@selector(scrollToTop) userInfo:nil repeats:NO];	
	}
}

//NSURLCONNECTION
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    NSLog(@"didReceiveResponse");	

	// This method is called when the server has determined that it
	// has enough information to create the NSURLResponse.
	
	
	// It can be called multiple times, for example in the case of a
	// redirect, so each time we reset the data.
	
	// receivedData is an instance variable declared elsewhere.
	NSHTTPURLResponse* httpResponse = (NSHTTPURLResponse*) response;	
	if( !emailNSURL )
	{
		_activityIndicator.hidden = NO;
		[_activityIndicator startAnimating];
		
		[storeData setLength:0];
	}
	else
	{
		NSLog(@"[email] Status code : %i", httpResponse.statusCode);
		responseURL = httpResponse.statusCode;
		[emailData setLength:0];		
	}
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    NSLog(@"didReceiveData");
	
    // Append the new data to receivedData.
    // receivedData is an instance variable declared elsewhere.
	
	if( !emailNSURL )
		[storeData appendData:data];
	else
		[emailData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    // release the connection, and the data object
	
    // receivedData is declared as a method instance elsewhere
	
	if( !emailNSURL )
	{
		[connection release];		
		[storeData release];
		storeData = nil;
	}
	else
	{
		if( [_Lang isEqualToString:@"en"] )
		{
			UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error!" message:@"We did not correctly received your email. Try again later!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
			[alert show];
			[alert release];
		}
		else if( [_Lang isEqualToString:@"fr"] )
		{
			UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Erreur !" message:@"Nous n'avons pas reçu votre email. Veuillez réessayer ultérieurement !" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
			[alert show];
			[alert release];			
		}
		
		[_submitConnection release];
		_submitConnection = nil;
		
		[_emailActivityIndicator stopAnimating];
		_sendEmail.hidden = NO;		
		_sendEmail.enabled = YES;
		
		[emailData release];
		emailData = nil;		
	}
	
    // inform the user
    //NSLog(@"connectiondidFailWithError - Connection failed! Error - %@ %@",
    //      [error localizedDescription],
     //     [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]);
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    // do something with the data
    // receivedData is declared as a method instance elsewhere
	
	if( !emailNSURL )
	{
		NSLog(@"connectionDidFinishLoading - Succeeded! Received %d bytes of data",[storeData length]);
		
		_activityIndicator.hidden = YES;
		[_activityIndicator stopAnimating];
		
		NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:storeData];
		
		//Set delegate
		[xmlParser setDelegate:self];
		
		//Start parsing the XML file.
		[xmlParser parse];	
		
		// release the connection, and the data object
		[xmlParser release];
		[connection release];
		[storeData release];
		storeData = nil;
	}
	else
	{
		NSLog(@"connectionDidFinishLoading - Succeeded! Received %d bytes of data",[emailData length]);
		
		if( responseURL == 200 )
		{
			if( [_Lang isEqualToString:@"en"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Email received!" message:@"Email successfully received! You are now registered in our iPhone newsletter!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
				[alert release];
			}
			else if( [_Lang isEqualToString:@"fr"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Email reçu !" message:@"Félicitations ! Vous êtes maintenant inscrits à notre newsletter iPhone !" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
				[alert release];			
			}
			_sendEmail.hidden = NO;
			_sendEmail.enabled = NO;
			_emailToGet.enabled = NO;
		}
		else if( responseURL == 403 || responseURL == 404 )
		{
			if( [_Lang isEqualToString:@"en"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error!" message:@"Your email adress is invalid. Try again!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
				[alert release];
			}
			else if( [_Lang isEqualToString:@"fr"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Erreur !" message:@"Votre adresse email est invalide, veuillez réessayer !" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
			}
			_sendEmail.hidden = NO;
			_sendEmail.enabled = YES;
			_emailToGet.enabled = YES;
		}
		else if( responseURL == 500 )
		{
			if( [_Lang isEqualToString:@"en"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error!" message:@"Your email adress is already registered!" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
				[alert release];
			}
			else if( [_Lang isEqualToString:@"fr"] )
			{
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Erreur !" message:@"Votre adresse email est déjà inscrite dans la base !" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
				[alert show];
			}
			_sendEmail.hidden = NO;
			_sendEmail.enabled = NO;
			_emailToGet.enabled = NO;
		}
		
		[_submitConnection release];
		_submitConnection = nil;
		
		[_emailActivityIndicator stopAnimating];

		//[connection release];
		[emailData release];
		emailData = nil;		
	}
}

//UIALERTVIEW
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex 
{
	
}

//UITEXTFIELDDELEGATE
- (BOOL) textFieldShouldReturn:(UITextField *)textField
{
    // the user pressed the "Done" button, so dismiss the keyboard
    [textField resignFirstResponder];
	
    return YES;
}

- (void) textFieldDidBeginEditing:(UITextField *)textField;
{
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];	
    [textField setPlaceholder:@""];	
}

- (void) textFieldDidEndEditing:(UITextField *)textField
{
	if( [textField.text isEqualToString:@""] )
	{
		if( [_Lang isEqualToString:@"en"] )
		{
			[_emailToGet setPlaceholder:@"Enter your email here..."];
		}
		else if( [_Lang isEqualToString:@"fr"] )
		{
			[_emailToGet setPlaceholder:@"Entrez votre adresse email ici..."];	
		}
	}
	
	if( textField.text.length > 0 )
		_sendEmail.enabled = YES;
	else
		_sendEmail.enabled = NO;
}

@end
